/**
 * NetCalc v2.4 [1430870400]
 * Copyright Expade, 2015. All rights reserved.
 *
 * Russian AG and HL Community: http://aghl.ru/forum/viewtopic.php?f=39&t=1600
 * Russian AMXX Community: http://amx-x.ru/viewtopic.php?f=9&t=34076
 */

#if defined _NetCalc_included
  #endinput
#endif
#define _NetCalc_included

// The maximum buffer size required to store an IP address.
#define MAX_IP_LENGTH 16

// Converts IP address to unsigned long.
stock inet_aton(const szIP[]) {
	new szTemp[MAX_IP_LENGTH], szOctet[4], aOctet[4];
	strtok(szIP, szOctet, charsmax(szOctet), szTemp, charsmax(szTemp), '.');

	for (new i = 0; i < 4; i++) {
		aOctet[i] = str_to_num(szOctet);
		if (aOctet[i] < 0) aOctet[i] = 0;
		if (aOctet[i] > 255) aOctet[i] = 0xFF;
		strtok(szTemp, szOctet, charsmax(szOctet), szTemp, charsmax(szTemp), '.');
	}

	return (aOctet[0] << 0x18) | (aOctet[1] << 0x10) | (aOctet[2] << 0x8) | aOctet[3];
}

// Converts unsigned long to IP address.
stock inet_ntoa(iIP) {
	new szIP[MAX_IP_LENGTH];
	formatex(szIP, charsmax(szIP), "%u.%u.%u.%u", iIP >> 0x18 & 0xFF, iIP >> 0x10 & 0xFF, iIP >> 0x8 & 0xFF, iIP & 0xFF);
	return szIP;
}

// Converts CIDR notation to unsigned long.
stock inet_mton(const szCIDR[]) {
	new iCIDR = str_to_num(szCIDR);
	if (iCIDR <= 0) return 0;
	if (iCIDR >= 32) return 0xFFFFFFFF;
	return 0xFFFFFFFF << (32 - iCIDR);
}

// Converts unsigned long to CIDR notation.
stock inet_ntom(iCIDR) {
	new iBits, szCIDR[3];
	for (iBits = 0; iCIDR; iBits++) iCIDR <<= 1;
	num_to_str(iBits, szCIDR, charsmax(szCIDR));
	return szCIDR;
}

// Gets IP address and CIDR notation as unsigned long.
stock bool:inet_range(const szSubnet[], &iIP, &iCIDR) {
	new szIP[MAX_IP_LENGTH], szCIDR[3];
	strtok(szSubnet, szIP, charsmax(szIP), szCIDR, charsmax(szCIDR), '/');
	iIP = inet_aton(szIP);
	iCIDR = szCIDR[0] ? inet_mton(szCIDR) : 0xFFFFFFFF;
	return iCIDR == 0xFFFFFFFF;
}

// Calculates the network-part (start IP address).
#define get_netpart(%1,%2) (%1 & %2)

// Calculates the machine-part (inversed netmask).
#define get_macpart(%1) (~%1)

// Calculates the broadcast (end IP address).
#define get_broadcast(%1,%2) (%1 | get_macpart(%2))

// Calculates the number of available addresses.
#define get_hostnum(%1,%2) (get_broadcast(%1,%2) - get_netpart(%1,%2) + 1)